#include <stdio.h> 
#include <stdlib.h> 
#include <math.h> 
#include "macro.h" 
#include "eglobal.h"

extern FILE *out;
extern void cg(), atxpxa(), free_dmatrix(),free_dvector(),
	    free_ivector();
extern double **dmatrix(int, int, int, int), *dvector(int, int);
extern int *ivector(int, int);

void initp()
 
/* Choosing the starting point (Bm, Cm)_0 for homotopy
  Results: Bm, Cm in input normal form (change in common block) */
{ 
      int ind ;
      register int i,j; 
      double eps=1.0e-26, f10av, f20av;

/* Compute B V B'  and save it in bvbt.           */
 
      mulmat1(b,v,temp1,n,m,m);
      mulmat3(temp1,b,bvbt,n,n,m);
 
/* Compute controllability Gramian Gc or Q        */
 
      trarray(a, tarray1,n,n);
      scmat(-1.00,bvbt,temp1,n,n);
      tmparray(temp1, tarray2,n,n);
#if ((AIX) || (HP))
      atxpxa(tarray1, ua, tarray2, &n, &n1, &n1, &n1,&eps,&ind);
#else
      atxpxa_(tarray1, ua, tarray2, &n, &n1, &n1, &n1,&eps,&ind);
#endif

      tmpmatrix(tarray2, qt1,n,n);
 
/* Compute C^t R C and save it in ctrc.            */
 
      mulmat2(c,r,temp1,n,l,l);
      mulmat1(temp1,c,ctrc,n,n,l);
 
/* Compute observability Gramian Go or P           */
 
      tmparray(a,tarray1,n,n);
      scmat(-1.00,ctrc,temp1,n,n);
      tmparray(temp1, tarray2,n,n);
#if ((AIX) || (HP))
      atxpxa(tarray1,ua,tarray2,&n,&n1,&n1,&n1,&eps,&ind);
#else
      atxpxa_(tarray1,ua,tarray2,&n,&n1,&n1,&n1,&eps,&ind);
#endif

      tmpmatrix(tarray2, pt1,n,n);
 
/* Compute the average of the two just solved equations */
 
      mulmat1(a,qt1,temp1,n,n,n);
      mulmat3(qt1,a,temp2,n,n,n);
      addmat1(temp1,temp2,temp3,n,n);
      addmat1(temp3,bvbt,ttemp1,n,n); 
 
      mulmat2(a,pt1,temp1,n,n,n);
      mulmat1(pt1,a,temp2,n,n,n);
      addmat1(temp1,temp2,temp3,n,n);
      addmat1(temp3,ctrc,ttemp2,n,n); 
 
      f10av  = f20av = 0.0;
      for(i=0;i<n;i++) 
        for(j=0;j<n;j++){
          f10av +=  fabs(ttemp1[i][j]);
          f20av +=  fabs(ttemp2[i][j]);
	  }
      if( f10av > 1.0e-03) 
        printf("A Q + A Q^t + BVB^t = %9.2E\n", f10av); 
      if( f20av > 1.0e-03) 
        printf("A^t P + P A + C^tRC = %9.2E\n", f20av);
     
/* Compute (W,U,Sigma) for given (Q,P)               */
 
     cg(n);
 
/* Compute the balanced form of (A,B,C)              */
 
      mulmat1(ttemp2,a,temp2,n,n,n);
      mulmat1(temp2,ttemp1,a,n,n,n);
      mulmat1(ttemp2,b,temp2,n,m,n);
      mulmat1(c,ttemp1,temp3,l,n,n); 
      scmat(1.0,temp2,b,n,m);
      scmat(1.0,temp3,c,l,n);  
 
/* Compute the initial conditions (A0,B0,C0) and (Am, Bm, Cm) */
 
      setmat(0.0,a0,n,n) ;
      for(i=0;i<nm;i++)
        for(j=0;j<nm;j++){
         a0[i][j] = a[i][j];
         am[i][j] = a0[i][j];
	 }
 
      for(i=nm;i<n;i++)
        for(j=nm;j<n;j++) a0[i][j] = a[i][j];
 
      setmat(0.0,b0,n,m); 
      for(j=0;j<m;j++)
        for(i=0;i<nm;i++){
         b0[i][j] = b[i][j];
         bm[i][j] = b0[i][j];
	 }
      
      setmat(0.0,c0,l,n); 
      for(j=0;j<nm;j++)
        for(i=0;i<l;i++){
         c0[i][j] = c[i][j];
         cm[i][j] = c0[i][j];
	 }

/* Transform the balanced (Am, Bm, Cm) to the desired form */

      setmat(0.0,am0,nm,nm);
      for(i=0;i<nm;i += 2) am0[i][i+1] = 1.0;
      setmat(0.0,cm0,l,nm);
      for(i=0;i<nm;i += 2) cm0[0][i] = 1.0;
 
/* Decide the transformation */
 
      if(nm == 1){ 
        am0[0][0] = am[0][0];
        cm0[0][0] = 1.0;
        eps = cm[0][0];
        scmat(eps,bm,bm0,nm,m); 
        eps = 1.0/cm[0][0];
        scmat(eps,cm,cm0,l,nm);
       scmat(1.0,am0,am,nm,nm);
       scmat(1.0,bm0,bm,nm,m);
       scmat(1.0,cm0,cm,l,nm);
        return;
      }
 
    if(nm == 2){
      eps= (am[0][1]* cm[0][0] -am[0][0]*cm[0][1])*cm[0][0]
          +(am[1][1]* cm[0][0] -am[1][0]*cm[0][1])*cm[0][1];
      temp1[1][0]= -(am[0][0]*cm[0][0]+am[1][0]*cm[0][1])/eps;
      temp1[1][1]= cm[0][0]/eps;
      temp1[0][0]= (1.0 - cm[0][1]*temp1[1][0])/cm[0][0];
      temp1[0][1]= -cm[0][1]/eps;
  
      eps = - temp1[0][1]*temp1[1][0] + temp1[0][0]*temp1[1][1];
      temp2[0][0]=  temp1[1][1]/eps; /* temp2 = temp1^-1 */
      temp2[0][1]= -temp1[0][1]/eps;
      temp2[1][0]= -temp1[1][0]/eps;
      temp2[1][1]=  temp1[0][0]/eps;
      am0[1][0] = am[0][1]*am[1][0]-am[0][0]*am[1][1]; /* S1 */
      am0[1][1] = am[0][0] + am[1][1];                 /* S2 */
      mulmat1(cm,temp1,cm0,l,nm,nm);
      mulmat1(temp2,bm,bm0,nm,m,nm);
       scmat(1.0,am0,am,nm,nm);
       scmat(1.0,bm0,bm,nm,m);
       scmat(1.0,cm0,cm,l,nm);
      return;
     }
 
    if(nm >= 3){ 
      int nm1, nm2, *ipvt, k, kk, nmk, nmk1; 
      double **qr, *y, *yf;
      
      nm2 = nm*nm;
      qr = dmatrix(0,nm2,0,nm2);
      y = dvector(0,(nm+2)*(nm+2));
      yf = dvector(0,(nm+2)*(nm+2));
      ipvt = ivector(0,(nm+2)*(nm+2));
 
/* Determine the eigenvalues of Am and order them */
 
      tmparray(am,tarray1,nm,nm);
      ind = nm + 2;
      k = 0;
#if ((AIX) || (HP))
      rg(&ind,&nm,tarray1,er,ei,&k,temp1,ipvt,yf,&kk);
#else
      rg_(&ind,&nm,tarray1,er,ei,&k,temp1,ipvt,yf,&kk);
#endif

      k= 0;
      kk=  0; 
      for(i=0;i<nm;i++){
	if(myabs(*(ei+i)) >= 1.0e-12) {
          *(ipvt+k) = i;
          k += 1;	
        }
        else{
	  *(ipvl+kk)= i;
	  kk += 1;
        }
       }
        for(j=0;j<k;j++){
         *(y+j) = *(er+ipvt[j]);
	 *(yf+j)= *(ei+ipvt[j]);
         }
        for(j=0;j<kk;j++){
         *(y+j+k) = *(er+ipvl[j]);
	 *(yf+j+k)= *(ei+ipvl[j]);
        }
 
/* Determine S */

      for(i=0;i<k;i += 2){
	*(scale+i) = -(y[i]*y[i] + yf[i]*yf[i]);
	*(scale+i+1) = 2*y[i];
      }
 
      for(i=k;i<nm;i += 2){
	*(scale+i) = - y[i]*y[i+1];
	*(scale+i+1) = y[i]+y[i+1];
       }
 
      if((nm-(nm/2)*2) > 0) *(scale+nm-1) = *(y+nm-1);
 
/* Determine the coeff. matrix for Solving am.T-T.S =0 and Cm.T =1010..
*/
      setmat(0.0, qr,nm2,nm2);
 
      for(k=0;k< nm/2;k++){
        nmk = nm*2*(k+1);
        nmk1= nm*2*k;
        for(i=0;i<nm;i++){
          for(j=0;j<nm;j++){
             qr[i+nmk1][j+nmk1] = am[i][j];
           if(i == j) 
             qr[i+nmk1+nm][j+nmk1+nm] = am[i][j]-scale[2*k+1];
           else
             qr[i+nmk1+nm][j+nmk1+nm] = am[i][j];
          }
         }           
 
        for(j=0;j<nm;j++){
           qr[j+nmk1][j+nmk1+nm] = -scale[2*k];
           qr[j+nmk1+nm][j+nmk1] = -1.0;
         }
       } 
 
      if((nm-(nm/2)*2) > 0){ 
       for(i=0;i<nm;i++) 
         for(j=0;j<nm;j++){
          if(i == j) 
            qr[i+nm*(nm-1)][j+nm*(nm-1)] = am[i][j]-scale[nm-1];
          else
            qr[i+nm*(nm-1)][j+nm*(nm-1)] = am[i][j];
          }
      }
 
      for(i=0;i<nm2;i += nm)
        for(j=0;j<nm2;j++)
         qr[i][j] = 0.0;
 
      k = 0;
      for(i=0;i<nm2;i += nm){
        for(j=0;j<nm;j++) qr[i][k*nm+j] = cm[0][j];
        k++;
       }
 
/* The left hand side of the equation */
 
      for(i=0;i<nm2;i++) *(y+i) = 0.0;
      for(i=0;i<nm2;i += 2*nm) *(y+i) = 1.0;
 
/* QR factorization of Coeff. matrix and solve for T*/
 
      ind =0;
      tmparray(qr,tarray1,nm2,nm2);
       nm1 = nm2 + 2;
#if ((AIX) || (HP))
       dgefa(tarray1,&nm1,&nm2,ipvt,&eps,tarray2);
#else
       dgefa_(tarray1,&nm1,&nm2,ipvt,&eps,tarray2);
#endif

#if ((AIX) || (HP))
       dgesl(tarray1,&nm1,&nm2,ipvt,y,&ind);
#else
       dgesl_(tarray1,&nm1,&nm2,ipvt,y,&ind);
#endif


      k = 0;
      for(i=0;i<nm;i++)
        for(j=0;j<nm;j++){
          temp1[j][i] = *(y+k);
          temp2[j][i] = *(y+k);
 	  k +=  1;
         }      

/* Compute the Inverse of T */
      tmparray(temp2,tarray1,nm,nm);
      nm1 = nm + 2;
#if ((AIX) || (HP))
      dgeco(tarray1,&nm1,&nm,ipvt,&eps,tarray2);
#else
      dgeco_(tarray1,&nm1,&nm,ipvt,&eps,tarray2);
#endif

      k = 1;
#if ((AIX) || (HP))
      dgedi(tarray1,&nm1,&nm,ipvt,tarray2,tarray2+3,&k);
#else
      dgedi_(tarray1,&nm1,&nm,ipvt,tarray2,tarray2+3,&k);
#endif


      tmpmatrix(tarray1,temp2,nm,nm);
  
      mulmat1(temp2,am,temp3,nm,nm,nm);
      mulmat1(temp3,temp1,am0,nm,nm,nm);
      mulmat1(cm,temp1,cm0,l,nm,nm);
      mulmat1(temp2,bm,bm0,nm,m,nm);

      free_dmatrix(qr,0,nm2,0,nm2);
      free_dvector(y,0,(nm+2)*(nm+2));
      free_dvector(yf,0,(nm+2)*(nm+2));
      free_ivector(ipvt,0,(nm+2)*(nm+2));
 
   } 
       scmat(1.0,am0,am,nm,nm);
       scmat(1.0,bm0,bm,nm,m);
       scmat(1.0,cm0,cm,l,nm);
}
