#include <stdlib.h>
#include <math.h>
#include "macro.h"
#include "eglobal.h"

void jaccm(double lambda, int k,int ll, double *y, int kk)
/* 
* JACCM evaluates kk-th column of Jacobian at given point w.r.t. Cm.
* Input parameters: k, ll -- the index of the element of Cm 
* Output parameters: * y - evaluated function
*/
{
      int ind;
      register int i,j;
      double eps = -1.0;

       setmat(0.0,att,nt,nt); /* Derivative of A tilde */
       setmat(0.0,temp1,n,nc); 
       for(i=0;i<nc;i++) temp1[i][ll] = bl[i][k];
       for(i=0;i<n;i++)      
	  for(j=n;j<nt;j++) att[i][j]=temp1[i][j-n];

       for (i=0;i<nt;i++) /* Derivative of R tilde inf     */  
	  for(j=0;j<nt;j++) rtt[i][j]=0.0; 

       setmat(0.0,temp1,nc,nc); /* Cc^t R2i E^(k,ll)+E^(ll,k) R2i Cc  */
       for(j=0;j<nc;j++) temp1[ll][j] = r2icc[k][j];
       trans(temp1,temp2,nc,nc);
       addmat1(temp1,temp2,ttemp1,nc,nc);
       for(i=n;i<nt;i++) /*  22 block of Rti^(j) */
	  for(j=n;j<nt;j++) rtt[i][j]=ttemp1[i-n][j-n];

       for (i=0;i<nt;i++) /* Derivative of R tilde in vtt */  
	  for(j=0;j<nt;j++) vtt[i][j]=0.0; 

       setmat(0.0,temp1,nc,nc); /* Cc^tR2E^(k,ll)+E^(ll,k) R2 Cc  */
       for(j=0;j<nc;j++) temp1[ll][j] = r2cc[k][j];
       trans(temp1,temp2,nc,nc);
       addmat1(temp1,temp2,ttemp1,nc,nc);
       for(i=n;i<nt;i++) /*  22 block of Rt^(j) */
	  for(j=n;j<nt;j++) vtt[i][j]=ttemp1[i-n][j-n];

      scmat(gaman2,rtt,ttemp2,nt,nt); /* Q^(j) */
      mulmat1(ttemp2,qt,ttemp1,nt,nt,nt);
      mulmat1(qt,ttemp1,ttemp2,nt,nt,nt);

      mulmat1(att,qt,ttemp1,nt,nt,nt);
      trans(ttemp1,ttemp3,nt,nt);
      addmat1(ttemp1,ttemp3,ttemp1,nt,nt);
      addmat4(ttemp1,ttemp2,ttemp1,nt,nt);
      tmparray(ttemp1,tarray2,nt,nt);

#if ((AIX) || (HP))
      atxpxa(ua,va,tarray2,&nt,&nt12,&nt12,&nt12,&eps,&ind);
#else
      atxpxa_(ua,va,tarray2,&nt,&nt12,&nt12,&nt12,&eps,&ind);
#endif

      tmpmatrix(tarray2,ttemp1,nt,nt);
      partition(ttemp1,qtd1,qtd12,qtd2,n,nt);

      mulmat1(ttemp1,rti,ttemp2,nt,nt,nt); /* Compute P^(j) */
      mulmat1(qt,rtt,ttemp1,nt,nt,nt);
      addmat1(ttemp1,ttemp2,ttemp3,nt,nt);
      scmat(gaman2,ttemp3,ttemp1,nt,nt);
      addmat1(att,ttemp1,ttemp1,nt,nt);
      mulmat2(ttemp1,pt,ttemp2,nt,nt,nt);
      trans(ttemp2,ttemp3,nt,nt);
      addmat1(ttemp2,ttemp3,ttemp1,nt,nt);
      addmat4(vtt,ttemp1,ttemp3,nt,nt);
      tmparray(ttemp3,tarray2,nt,nt);

#if ((AIX) || (HP))
      atxpxa(uat,vat,tarray2,&nt,&nt12,&nt12,&nt12,&eps,&ind);
#else
      atxpxa_(uat,vat,tarray2,&nt,&nt12,&nt12,&nt12,&eps,&ind);
#endif

      tmpmatrix(tarray2,ttemp1,nt,nt);
      partition(ttemp1,ptd1,ptd12,ptd2,n,nt);
         
/* Compute derivative of H_Ac  */
 
       hachat(); 
       j = 0;
       for(i=0;i<nc/2;i++){
          *(y+j) = ttemp3[2*i+1][2*i];
          *(y+j+1) = ttemp3[2*i+1][2*i+1];
          j += 2;
        } 
        *(y + nc -1) = ttemp3[nc-1][nc-1];

/* Compute derivative of H_Bc  */
 
      hbchat();
      toarray(nc,l,ttemp3,y+nc);
 
/* Compute derivative of H_Cc       */

     if( m > 1) {
/* Originial terms                  */ 
       hcchat();

       setmat(0.00,temp2,m,nc);
       for(j=0;j<nc;j++) temp2[k][j] = qt2[ll][j];
       scmat(lambda,r2dot,ttemp1,m,m);
       addmat1(r20,ttemp1,ttemp2,m,m); /* R2 (lambda) */
       mulmat1(ttemp2,temp2,temp4,m,nc,m);

       eps = 0.5 * gaman2;
       scmat(eps,cy,temp3,nc,nc);

       setmat(0.00,temp2,m,nc);
       for(j=0;j<nc;j++) temp2[k][j] = temp3[ll][j];

       scmat(lambda,r2idot,ttemp1,m,m);  /* R2i(lambda)  */
       addmat1(r2i0,ttemp1,ttemp2,m,m);
       mulmat1(ttemp2,temp2,temp3,m,nc,m);

       addmat1(temp4,temp3,temp1,m,nc);
       
       addmat1(ttemp3,temp1,temp2,m,nc);

        k = nc + nc*l;
        for(i=1;i<m;i++)
          for(j=0;j<nc;j++){
            *(y+k) = temp2[i][j];    
            k++;
         }
      }
      for (i =0;i<nn;i++) y[i] = lambda * y[i];
      y[kk-2] += 1 - lambda;

}
