#include <stdlib.h>
#include <math.h>
#include "macro.h"
#include "eglobal.h"


void jacam(double lambda, int k,int ll, double *y) 
/*
* JACAM -- evaluates kk-th column of Jacobian at given point
*           with respect to Ac. or w.r.t. Ac_kl 
* Input parameters: k, ll -- the index of the element of Ac
* Output parameters: y - evaluated function 
*/
{
      int ind;
      register int i,j;
      double eps = -1.0;
 
      setmat(0.0,att,nt,nt); /* Derivative of A tilde */
      att[n+k][n+ll] = 1.0;
         
      mulmat1(att,qt,ttemp1,nt,nt,nt); /* Compute Q^(j)*/
      trans(ttemp1,ttemp2,nt,nt);
      addmat4(ttemp1,ttemp2,ttemp3,nt,nt);
      tmparray(ttemp3,tarray2,nt,nt);

#if ((AIX) || (HP))
      atxpxa(ua,va,tarray2,&nt,&nt12,&nt12,&nt12,&eps,&ind);
#else
      atxpxa_(ua,va,tarray2,&nt,&nt12,&nt12,&nt12,&eps,&ind);
#endif

      tmpmatrix(tarray2,ttemp1,nt,nt);
      partition(ttemp1,qtd1,qtd12,qtd2,n,nt);

      mulmat1(ttemp1,rti,ttemp2,nt,nt,nt); /* Compute P^(j) */
      scmat(gaman2,ttemp2,ttemp2,nt,nt);
      addmat1(att,ttemp2,ttemp3,nt,nt);
      mulmat2(ttemp3,pt,ttemp1,nt,nt,nt);
      trans(ttemp1,ttemp2,nt,nt);
      addmat4(ttemp2,ttemp1,ttemp3,nt,nt);
      tmparray(ttemp3,tarray2,nt,nt);

#if ((AIX) || (HP))
      atxpxa(uat,vat,tarray2,&nt,&nt12,&nt12,&nt12,&eps,&ind);
#else
      atxpxa_(uat,vat,tarray2,&nt,&nt12,&nt12,&nt12,&eps,&ind);
#endif

      tmpmatrix(tarray2,ttemp1,nt,nt);
      partition(ttemp1,ptd1,ptd12,ptd2,n,nt);
 
/* Compute derivatives of H_Ac */

       hachat();
       scmat(lambda,ttemp3,ttemp3,nc,nc);
       ttemp3[k][ll] += 1.0 - lambda;
       toarray(nc,nc,ttemp3,y);
 
/* Compute derivatives of H_Bc */

        hbchat();
        scmat(lambda,ttemp3,ttemp3,nc,l);
        toarray(nc,l,ttemp3,y+nc*nc);
 
/* Compute derivatives of H_Cc */
/* Original terms              */ 

        hcchat();
        scmat(lambda,ttemp3,ttemp3,m,nc);
        toarray(m,nc,ttemp3,y+nc*nc +nc*l);
} 
