#include <stdlib.h>
#include <math.h>
#include "macro.h"
#include "eglobal.h"

void jacbm(double lambda, int k,int ll, double *y) 
/*
* JACBM -- evaluates kk-th column of Jacobian at given point
*           with respect to Bc. or w.r.t. Bc_kl 
* Input parameters: k, ll -- the index of the element of Bc
* Output parameters: y - evaluated function 
*/
{
      int ind;
      register int i,j;
      double eps = -1.0;

       setmat(0.0,att,nt,nt); /* Derivative of A tilde */
       setmat(0.0,temp1,nc,n); 
       for(i=0;i<n;i++) temp1[k][i] = cl[ll][i];
       for(i=n;i<nt;i++)      
	  for(j=0;j<n;j++) att[i][j]=temp1[i-n][j];

       for(i=0;i<nt;i++) /* Derivative of V tilde         */
	  for(j=0;j<nt;j++) vtt[i][j]=0.0;  

       setmat(0.0,temp1,nc,nc); /* BcV2E^(ll,k)+E^(k,ll)V2Bc^T */
       for(i=0;i<nc;i++) temp1[i][k] = bcv2[i][ll];
       trans(temp1,temp2,nc,nc);
       addmat1(temp1,temp2,ttemp3,nc,nc);
       for(i=n;i<nt;i++)       /* 22 block of Vt^(j)      */ 
	  for(j=n;j<nt;j++) vtt[i][j]=ttemp3[i-n][j-n];
         
      mulmat1(att,qt,ttemp1,nt,nt,nt); /* Compute Q^(j)*/
      trans(ttemp1,ttemp2,nt,nt);
      addmat1(ttemp1,ttemp2,ttemp3,nt,nt);
      addmat4(vtt,ttemp3,ttemp1,nt,nt);
      tmparray(ttemp1,tarray2,nt,nt);

#if ((AIX) || (HP))
      atxpxa(ua,va,tarray2,&nt,&nt12,&nt12,&nt12,&eps,&ind);
#else
      atxpxa_(ua,va,tarray2,&nt,&nt12,&nt12,&nt12,&eps,&ind);
#endif

      tmpmatrix(tarray2,ttemp1,nt,nt);
      partition(ttemp1,qtd1,qtd12,qtd2,n,nt);

      mulmat1(ttemp1,rti,ttemp2,nt,nt,nt); /* Compute P^(j) */
      scmat(gaman2,ttemp2,ttemp2,nt,nt);
      addmat1(att,ttemp2,ttemp1,nt,nt);
      mulmat2(ttemp1,pt,ttemp3,nt,nt,nt);
      trans(ttemp3,ttemp1,nt,nt);
      addmat4(ttemp1,ttemp3,ttemp3,nt,nt);
      tmparray(ttemp3,tarray2,nt,nt);

#if ((AIX) || (HP))
      atxpxa(uat,vat,tarray2,&nt,&nt12,&nt12,&nt12,&eps,&ind);
#else
      atxpxa_(uat,vat,tarray2,&nt,&nt12,&nt12,&nt12,&eps,&ind);
#endif

      tmpmatrix(tarray2,ttemp1,nt,nt);
      partition(ttemp1,ptd1,ptd12,ptd2,n,nt);
 
/* Compute derivatives of H_Ac */

        hachat();
        scmat(lambda,ttemp3,ttemp3,nc,nc);
        toarray(nc,nc,ttemp3,y);

/* Compute derivatives of H_Bc */

        hbchat();
        setmat(0.0,temp1,nc,l);
        for(j=0;j<l;j++)
          temp1[k][j] = v20[ll][j] + lambda *v2dot[ll][j];
 	mulmat1(pt2,temp1,temp3,nc,l,nc);

        addmat1(temp3,ttemp3,temp1,nc,l);

        scmat(lambda,temp1,temp1,nc,l);
        temp1[k][ll] += 1.0 - lambda;
        toarray(nc,l,temp1,y+nc*nc);
 
/* Compute derivatives of H_Cc */
/* Original terms              */ 

        hcchat();  
        scmat(lambda,ttemp3,ttemp3,m,nc);
        toarray(m,nc,ttemp3,y+nc*nc+nc*l);
} 
