#include <stdlib.h>
#include <math.h>
#include "macro.h"
#include "eglobal.h"

extern void riccnd(), atxpxa();

void jaclam(double lambda, double *y)
/*
JACLAM evaluates 1-th column of Jacobian (w.r.t Lambda) at given point.
* Input parameters: lambda 
* Output parameters: y - evaluated function
*/
{
      int ind;
      register int i,j, k;
      double eps;

      /* Compute A tilde dot  */
      mulmat1(bdot,cc,ttemp1,n,nc,m);
      mulmat1(bc,cdot,ttemp2,nc,n,l);
      setmat(0.0,ttemp3,nc,nc);
      tkblockf(att,adot,ttemp1,ttemp2,ttemp3,n,nt);

      /* Compute V tilde dot  */
      mulmat1(bc,v2dot,temp3,nc,l,l);
      mulmat3(temp3,bc,temp1,nc,nc,l);
      tkblockp(vtt,v1dot,temp1,n,nt);

      /* Compute R tilde inf dot  */
      mulmat2(cc,r2idot,temp3,nc,m,m);
      mulmat1(temp3,cc,temp1,nc,nc,m);
      tkblockp(rtt,r1idot,temp1,n,nt);

      mulmat1(att,qt,ttemp1,nt,nt,nt); /* Compute Qt dot*/
      trans(ttemp1,ttemp2,nt,nt);
      addmat1(ttemp1,ttemp2,ttemp3,nt,nt);
      addmat1(ttemp3,vtt,ttemp3,nt,nt);

      mulmat1(qt, rtt, ttemp1, nt,nt,nt);
      mulmat1(ttemp1,qt,ttemp2,nt,nt,nt);
      scmat(gaman2, ttemp2, ttemp2, nt,nt);

      addmat1(ttemp3,ttemp2,ttemp3,nt,nt);

      mulmat1(qt, rti, ttemp1, nt,nt,nt);
      mulmat1(ttemp1,qt,ttemp2,nt,nt,nt);
      eps = - 2.0 *(gf - g0) *gaman2 / gama;
      scmat(eps, ttemp2, ttemp2, nt,nt);

      addmat4(ttemp3,ttemp2,ttemp1,nt,nt);

      tmparray(ttemp1,tarray2,nt,nt);

      mulmat1(qt,rti,ttemp1,nt,nt,nt);
      scmat(gaman2,ttemp1,ttemp1,nt,nt);
      addmat1(at,ttemp1,ttemp2,nt,nt);
      trarray(ttemp2,ua,nt,nt); 

      eps = 1.0e-26;
#if ((AIX) || (HP))
      atxpxa(ua,va,tarray2,&nt,&nt12,&nt12,&nt12,&eps,&ind);
#else
      atxpxa_(ua,va,tarray2,&nt,&nt12,&nt12,&nt12,&eps,&ind);
#endif


      tmpmatrix(tarray2,ttemp2,nt,nt);
      partition(ttemp2,qtd1,qtd12,qtd2,n,nt);

      mulmat1(ttemp2,rti,ttemp1,nt,nt,nt); /* Compute Ptilde dot */
      scmat(gaman2,ttemp1,ttemp1,nt,nt); 
      addmat1(att,ttemp1,ttemp2,nt,nt);

      mulmat1(qt, rti, ttemp1, nt,nt,nt);
      eps = - 2.0*(gf - g0)*gaman2 / gama;
      scmat(eps, ttemp1, ttemp3, nt,nt);

      addmat1(ttemp2,ttemp3,ttemp1,nt,nt);

      mulmat1(qt,rtt,ttemp2,nt,nt,nt);
      scmat(gaman2,ttemp2,ttemp3,nt,nt);
      addmat1(ttemp3,ttemp1,ttemp1,nt,nt);

      mulmat2(ttemp1,pt,ttemp2,nt,nt,nt);
      trans(ttemp2,ttemp1,nt,nt);  
      addmat1(ttemp2,ttemp1,ttemp3,nt,nt);

      /* Compute R tilde dot  */
      mulmat2(cc,r2dot,temp3,nc,m,m);
      mulmat1(temp3,cc,temp1,nc,nc,m);
      tkblockp(vtt,r1dot,temp1,n,nt);

      addmat4(ttemp3,vtt,ttemp3,nt,nt);

      tmparray(ttemp3,tarray2,nt,nt);
     
      eps = -1.0 ;
#if ((AIX) || (HP))
      atxpxa(uat,vat,tarray2,&nt,&nt12,&nt12,&nt12,&eps,&ind);
#else
      atxpxa_(uat,vat,tarray2,&nt,&nt12,&nt12,&nt12,&eps,&ind);
#endif

      tmpmatrix(tarray2,ttemp1,nt,nt);
      partition(ttemp1,ptd1,ptd12,ptd2,n,nt);

/* Compute derivative of H_Ac       */
      
        hachat(); 
        scmat(lambda,ttemp3,ttemp3,nc,nc);
        addmat3(ac,ac0,ttemp1,nc,nc);
        addmat3(ttemp3,ttemp1,ttemp3,nc,nc);
        addmat1(hac,ttemp3,ttemp3,nc,nc);
					
        toarray(nc,nc,ttemp3,y);
 
/* Compute derivative of H_Bc       */
 
        hbchat();

        mulmat3(temp4,cdot,ttemp1,nc,l,n);
        addmat1(ttemp1,ttemp3,ttemp3,nc,l);
        mulmat1(bc,v2dot,ttemp2,nc,l,l);
        mulmat1(pt2,ttemp2,ttemp1,nc,l,nc);
        addmat1(ttemp1,ttemp3,ttemp3,nc,l);

        scmat(lambda,ttemp3,ttemp3,nc,l);
        addmat3(bc,bc0,ttemp1,nc,l);
        addmat3(ttemp3,ttemp1,ttemp3,nc,l);
        addmat1(hbc,ttemp3,ttemp3,nc,l);

        toarray(nc,l,ttemp3,y+nc*nc);
 
/* Compute derivatives of H_Cc     */
/* Original terms in temp1         */
        mulmat2(bdot,temp2,ttemp1,m,nc,n);
        mulmat1(r2icc,cy,ttemp2,m,nc,nc);
        eps = - (gf - g0)*gaman2/gama;
        scmat(eps,ttemp2,ttemp3,m,nc);
        addmat1(ttemp1,ttemp3,temp4,m,nc);

        mulmat1(r2dot,cc,ttemp2,m,nc,m);
        mulmat1(ttemp2,qt2,ttemp1,m,nc,nc);

        addmat1(ttemp1,temp4,temp4,m,nc);
         
        mulmat1(r2idot,cc,ttemp2,m,nc,m);
        mulmat1(ttemp2,cy,ttemp1,m,nc,nc);
        eps = 0.5 * gaman2;
        scmat(eps,ttemp1,ttemp3,m,nc)

        addmat1(temp4,ttemp3,temp4,m,nc);

        hcchat();
         
        addmat1(temp4,ttemp3,temp2,m,nc);

        scmat(lambda,temp2,temp2,m,nc);
        addmat3(cc, cc0,temp1,m,nc);
        addmat3(temp2,temp1,temp3,m,nc);
        addmat1(hcc,temp3,temp2,m,nc);
        toarray(m,nc,temp2,y+nc*nc+l*nc);
              
}
