#include <stdio.h> 
#include <stdlib.h> 
#include <math.h> 
#include "macro.h" 
#include "eglobal.h"

extern FILE *out;
extern void cg(), atxpxa();

void initp()
 
/* Choosing the starting point (Bm, Cm)_0 for homotopy
  Results: Bm, Cm in input normal form (change in common block) */
{ 
      int ind;
      register int i,j; 
      double eps=1.0e-26, f10av, f20av;

/* Compute B V B'  and save it in bvbt.           */
 
      mulmat1(b,v,temp1,n,m,m);
      mulmat3(temp1,b,bvbt,n,n,m);
 
/* Compute controllability Gramian Gc or Q        */
 
      trarray(a, tarray1,n,n);
      scmat(-1.00,bvbt,temp1,n,n);
      tmparray(temp1, tarray2,n,n);
#if ((AIX) || (HP))
      atxpxa(tarray1, ua, tarray2, &n, &n1, &n1, &n1,&eps,&ind);
#else
      atxpxa_(tarray1, ua, tarray2, &n, &n1, &n1, &n1,&eps,&ind);
#endif
      tmpmatrix(tarray2, qt1,n,n);
 
/* Compute C^t R C and save it in ctrc.            */
 
      mulmat2(c,r,temp1,n,l,l);
      mulmat1(temp1,c,ctrc,n,n,l);
 
/* Compute observability Gramian Go or P           */
 
      tmparray(a,tarray1,n,n);
      scmat(-1.00,ctrc,temp1,n,n);
      tmparray(temp1, tarray2,n,n);
#if ((AIX) || (HP))
      atxpxa(tarray1,ua,tarray2,&n,&n1,&n1,&n1,&eps,&ind);
#else
      atxpxa_(tarray1,ua,tarray2,&n,&n1,&n1,&n1,&eps,&ind);
#endif
      tmpmatrix(tarray2, pt1,n,n);
 
/* Compute the average of the two just solved equations */
 
      mulmat1(a,qt1,temp1,n,n,n);
      mulmat3(qt1,a,temp2,n,n,n);
      addmat1(temp1,temp2,temp3,n,n);
      addmat1(temp3,bvbt,ttemp1,n,n); 
 
      mulmat2(a,pt1,temp1,n,n,n);
      mulmat1(pt1,a,temp2,n,n,n);
      addmat1(temp1,temp2,temp3,n,n);
      addmat1(temp3,ctrc,ttemp2,n,n); 
 
      f10av  = f20av = 0.0;
      for(i=0;i<n;i++) 
        for(j=0;j<n;j++){
          f10av +=  fabs(ttemp1[i][j]);
          f20av +=  fabs(ttemp2[i][j]);
	  }
       
      if(f10av > 1.0e-3)
        printf("A Q + A Q^t + BVB^t = %9.2E\n", f10av); 
      if(f20av > 1.0e-3)
        printf("A^t P + P A + C^tRC = %9.2E\n", f20av);
 
/* Compute (W,U,Sigma) for given (Q,P)               */
 
     cg(n);
 
/* Compute the balanced form of (A,B,C)              */
 
      mulmat1(ttemp2,a,temp2,n,n,n);
      mulmat1(temp2,ttemp1,a,n,n,n);
      mulmat1(ttemp2,b,temp2,n,m,n);
      mulmat1(c,ttemp1,temp3,l,n,n); 
      scmat(1.0,temp2,b,n,m);
      scmat(1.0,temp3,c,l,n);  
 
/* Compute the initial conditions (A0,B0,C0) and (Am, Bm, Cm) */
 
      setmat(0.0,a0,n,n) ;
      for(i=0;i<nm;i++)
        for(j=0;j<nm;j++){
         a0[i][j] = a[i][j];
         ami[i][j] = a0[i][j];
	 }
 
      for(i=nm;i<n;i++)
        for(j=nm;j<n;j++) a0[i][j] = a[i][j];
 
      setmat(0.0,b0,n,m); 
      for(j=0;j<m;j++)
        for(i=0;i<nm;i++){
         b0[i][j] = b[i][j];
         bmi[i][j] = b0[i][j];
	 }
      
      setmat(0.0,c0,l,n); 
      for(j=0;j<nm;j++)
        for(i=0;i<l;i++){
         c0[i][j] = c[i][j];
         cmi[i][j] = c0[i][j];
	 }

/* print out the results for balanced form    */

/*    for(i=0;i<nm;i++)
        for(j=0;j<nm;j++) fprintf(out,"%19.10E\n", ami[i][j]);
      for(i=0;i<nm;i++) fprintf(out,"%19.10E\n", bmi[i][0]);
      for(j=0;j<nm;j++) fprintf(out,"%19.10E\n", cmi[0][j]); */

/* compute the cost of balanced form        */

/*    mulmat1(b,v,bv,n,m,m);
      mulmat3(bv,bmi,bvbmt,n,nm,m);
      mulmat3(bv,b,bvbt,n,n,m);

      mulmat1(bmi,v,bmv,nm,m,m);
      mulmat3(bmv,bmi,bmvbmt,nm,nm,m);
 
      setmat(0.0,ttemp2,n,nm);
      takeblock(at,a,ttemp2,ami,n,nt); 
      trarray(at,uat,nt,nt);
	
      takeblock(vt,bvbt,bvbmt,bmvbmt,n,nt); 
      tmparray(vt,ua,nt,nt);
      scmat(-1.0,vt,ttemp1,nt,nt);
      tmparray(ttemp1,ua,nt,nt);
#if ((AIX) || (HP))
      atxpxa(uat, tarray1, ua, &nt, &nt12, &nt12, &nt12, &eps, &ind);
#else
      atxpxa_(uat, tarray1, ua, &nt, &nt12, &nt12, &nt12, &eps, &ind);
#endif

      tmpmatrix(ua,qt,nt,nt);

      mulmat1(r,c,rc,l,n,l);
      mulmat2(c,rc,ctrc,n,n,l) ;
 
      mulmat1(r,cmi,rcm,l,nm,l);
      mulmat2(c,rcm,ctrcm,n,nm,l); 
      mulmat2(cmi,rcm,cmtrcm,nm,nm,l);
 
      scmat(-1.0, ctrcm, ttemp2,n,nm);
      takeblock(rt,ctrc,ttemp2,cmtrcm,n,nt); 

      mulmat1(qt,rt,ttemp1,nt,nt,nt);

     f10av =0.0;
       for(i=0;i<nt;i++) f10av += ttemp1[i][i];
     fprintf(out,"\nThe cost for balanced form is %19.7E\n", f10av);
     printf("\nThe cost for balanced form is %19.7E\n", f10av); */

/* Compute U =Sigma^0.5,  U^-1 =Sigma^-0.5         */
 
       setmat(0.0,qt1,nm,nm);
       setmat(0.0,pt1,nm,nm);
       setmat(0.0,ome,nm,nm);
       for(i=0;i<nm;i++){
         qt1[i][i] = sqrt(ttemp3[i][i]);
         pt1[i][i] = 1/qt1[i][i];
         ome[i][i] = ttemp3[i][i]*ttemp3[i][i];
       }
 
/* Compute the input normal form of (Am,Bm,Cm)   */
 
      mulmat1(pt1,ami,temp1,nm,nm,nm);
      mulmat1(temp1,qt1,ami,nm,nm,nm);
      mulmat1(pt1,bmi,temp1,nm,m,nm);
      scmat(1.0, temp1,bmi,nm,m);
      mulmat1(cmi,qt1,temp1,l,nm,nm);
      scmat(1.0, temp1,cmi,l,nm);
 
/* Compute the acuracy of input normal form       */
 
      mulmat1(bmi,v,temp1,nm,m,m);
      mulmat3(temp1,bmi,temp2,nm,nm,m);
      trans(ami,temp1,nm,nm);
      addmat1(ami,temp1,temp3,nm,nm);
      addmat1(temp2,temp3,temp1,nm,nm);
 
      mulmat2(cmi,r,temp2,nm,l,l);
      mulmat1(temp2,cmi,temp3,nm,nm,l);
      for(i=0;i<nm;i++)
        for(j=0;j<nm;j++)
         temp2[i][j]=ami[j][i]*ome[j][j]+ome[i][i]*ami[i][j] + 
                     temp3[i][j];
 
      f10av  = f20av = 0.0;
      for(i=0;i<nm;i++)
        for(j=0;j<nm;j++){
          f10av +=  fabs(temp1[i][j]);
          f20av +=  fabs(temp2[i][j]);
         }
      f10av /=  (nm*nm);
      f20av /=  (nm*nm);
      if(f10av > 1.0e-3 || f20av > 1.0e-3)
       printf("Input normal form equation average %9.2E %9.2E \n", f10av,
      f20av);
}
