      subroutine apprd(ld,n,nm,nn,d,bvbt,ctrc,y,hom,ww,wi,sigma,
     &                 f10,f20,f30,temp1,temp2,temp3,qr,wa,fvec,s1)
*
* Quasi-Newton iteration for solving initial problem (matrix D)
*
* Input parameters:
* ld - leading dimension of matrices
* n,nm - dimensions of system and model
* nn - Jacobian size
* d,bvbt,ctrc - D, B V B^t, C^t R C
* y - starting point in vector form
*
* Output parameters:
* y - final point in vector form
* hom - parameter indicating which homotopy map will be used, depends
*       on the result of quasi-Newton iteration
*
* Working storage:
* ww,wi,sigma,f10,f20,f30,temp1,temp2,temp3,qr - working matrices
* wa,fvec,s1 - working arrays
*
      external fcn
      integer hom,ld,ldfjac,lwa,n,nm,nn
      double precision bvbt(ld,ld),ctrc(ld,ld),d(ld,ld),eps,f10(ld,ld)
      double precision f20(ld,ld),f30(ld,ld),fvec(nn),qr(nn,nn),s1(ld)
      double precision sigma(ld,ld),temp1(ld,ld),temp2(ld,ld)
      double precision temp3(ld,ld),wa(nn*(n+13)/2),wi(ld,ld)
      double precision ww(ld,ld),y(nn)
*
      ldfjac = nn
      lwa = nn*(nn+13)/2
      hom = 0
      eps = 1.d-5
*
      call f0s(ld,n,nm,ww,wi,sigma,f10,f20,f30,d,bvbt,ctrc,
     &         temp1,temp2,temp3)
*
* Transfer point from matrix to vector form
*
      call xwus(ld,n,nm,2,ww,wi,sigma,y)
*
      write(2,201)
201   format(/'apprd y0')
      call writev(y,nn)
*
* Perform quasi-Newton iteration
*
      call hybrj1(fcn,nn,y,fvec,qr,ldfjac,eps,hom,wa,lwa)
*
      write(6,202)hom
      write(2,202)hom
202   format(/'apprd hom =',i3)
*
      write(2,203)
203   format(/'apprd y')
      call writev(y,nn)
*
* Transfer point from vector to matrix form
*
      call xwus(ld,n,nm,1,ww,wi,sigma,y)
*
      return
      end
