      subroutine low(ld,ld4,n,nm,m,l,nn,ch,trace,y,a,bvbt,ctrc,am,bm,cm,
     & b,c,v,r,q,p,tau,ww,wi,sigma,temp1,temp2,temp3,aal,
     & at,bt,ct,vt,rt,temp4,temp5,temp6,mat2,e1,e2,s1,fvec,qr,wa)
*
* Compute a solution using a solution of a lower order
*
      integer ch,i,j,l,ld,m,n,nm,nn,trace,xtyp,z
      double precision a(ld,ld),aal(ld,ld),am(ld,ld),b(ld,ld),bm(ld,ld)
      double precision bvbt(ld,ld),c(ld,ld),cm(ld,ld),ctrc(ld,ld)
      double precision p(ld,ld),q(ld,ld),qr(350,350),r(ld,ld)
      double precision sigma(ld,ld),small,t1,t2,tau(ld,ld)
      double precision temp1(ld,ld),temp2(ld,ld),temp3(ld,ld)
      double precision v(ld,ld),wa(60000),wi(ld,ld),ww(ld,ld),y(*)
*
      z = ld * ld
      small = 1.d-1
*
      call bvrc(ld,n,m,l,b,c,bvbt,ctrc,v,r,temp1)
*
      nn = 2*n*nm + nm*nm
*
      goto (401,402,403,404,405,406) ch
*
* Strategy 1 for choosing the starting point
*
401   continue
        t1 = small
        t2 = t1
        do 321 i = 1,n
          ww(i,nm) = t1
          wi(nm,i) = t1
          t1 = t1 + t2
321     continue
      goto 407
*
* Strategy 2 for choosing the starting point
*
402   continue
        ww(n,nm) = small
        wi(nm,n) = small
      goto 407
*
* Strategy 3 for choosing the starting point
*
403   continue
        do 331 i = 1,n
          ww(i,nm) = ww(i,nm-1)
          wi(nm,i) = wi(nm-1,i)
331     continue
        do 332 i = 1,nm-1
          sigma(nm,i) = sigma(nm-1,i)
          sigma(i,nm) = sigma(i,nm-1)
332     continue
      goto 407
*
* Strategy 4 for choosing the starting point
*
404   continue
        t1 = 0.d0
        do 336 i = 1,nm-1
          t1 = t1 + sigma(i,i)
336     continue
        sigma(nm,nm) = t1 / dble(nm-1)
        write(2,241)
241     format('sigma')
        call writem(ld,sigma,nm,nm)
        call mulmat(ld,ww,sigma,temp1,n,nm,nm,1)
        call mulmat(ld,temp1,ww,q,n,n,nm,3)
        call mulmat(ld,wi,sigma,temp1,n,nm,nm,2)
        call mulmat(ld,temp1,wi,p,n,n,nm,1)
*
      call cg(ld,n,nm,q,p,ww,wi,sigma,tau,temp1,temp2,temp3,
     &        wa(1),wa(z+1),wa(2*z+1),wa(3*z+1),wa(4*z+1),wa(5*z+1),
     &        wa(6*z+1),wa(7*z+1),wa(8*z+1),wa(9*z+1),wa(10*z+1),
     &        wa(11*z+1))
*
        write(2,241)
        call writem(ld,sigma,nm,nm)
      goto 407
*
* Strategy 5 for choosing the starting point
*
405   continue
        do 351 i = nm,2,-1
          do 352 j = 1,n
            ww(j,i) = ww(j,i-1)
            wi(i,j) = wi(i-1,j)
352       continue
351     continue
        do 353 i = nm,2,-1
          do 354 j = nm,2,-1
            sigma(i,j) = sigma(i-1,j-1)
354       continue
353     continue
        do 355 i = 1,n
          ww(i,1) = 0.d0
          wi(1,i) = 0.d0
355     continue
        ww(n,1) = small
        wi(1,n) = small
        call writem(ld,ww,n,nm)
        call writem(ld,wi,nm,n)
        call writem(ld,sigma,nm,nm)
      goto 407
*
* Strategy 6 for choosing the starting point
*
406   continue
        nm = nm - 1
        write(2,241)
        call writem(ld,sigma,nm,nm)
        call writem(ld,ww,n,nm)
        call writem(ld,wi,nm,n)
        call mulmat(ld,ww,sigma,temp1,n,nm,nm,1)
        call mulmat(ld,temp1,ww,q,n,n,nm,3)
        call mulmat(ld,wi,sigma,temp1,n,nm,nm,2)
        call mulmat(ld,temp1,wi,p,n,n,nm,1)
      call cg(ld,n,nm,q,p,ww,wi,sigma,tau,temp1,temp2,temp3,
     &        wa(1),wa(z+1),wa(2*z+1),wa(3*z+1),wa(4*z+1),wa(5*z+1),
     &        wa(6*z+1),wa(7*z+1),wa(8*z+1),wa(9*z+1),wa(10*z+1),
     &        wa(11*z+1))
        call writem(ld,ww,n,nm)
        call writem(ld,wi,nm,n)
        nm = nm + 1
        t1 = 0.d0
        do 362 i = 1,nm-1
          t1 = t1 + sigma(i,i)
362     continue
*        sigma(nm,nm) = t1 / dble(nm-1)
        sigma(nm,nm) = small
        write(2,241)
        call writem(ld,sigma,nm,nm)
      goto 407
407   continue
*
      xtyp = 2
      call xwus(ld,n,nm,xtyp,ww,wi,sigma,y)
*
* Perform Quasi-Newton iteration
*
      call appra(ld,ld4,n,nm,m,l,nn,trace,y,a,bvbt,ctrc,am,bm,cm,b,c,
     &           v,r,q,p,tau,ww,wi,sigma,temp1,temp2,temp3,aal,
     &           at,bt,ct,vt,rt,temp4,temp5,temp6,mat2,e1,e2,s1,
     &           fvec,qr,wa)
*
      return
      end
