      subroutine quick(ld,ld4,n,nm,m,l,nn,trace,y,a,b,c,d,v,r,bvbt,ctrc,
     & ww,wi,sigma,q,p,tau,am,bm,cm,temp1,temp2,temp3,lu,gc,go,s,e,work,
     & aal,mat2,qr,wa,fvec,s,s1,e,e1,e2,temp4,temp5,temp6,at,bt,ct,vt,
     & rt)
*
* Compute rank-nm modifications of Gramians and
* perform Quasi-Newton iteration
*
      integer i,ind,j,job,l,ld,ld4,m,n,nm,nn,trace,xtyp,z
      double precision a(ld,ld),aal(ld,ld),am(ld,ld),at(ld4,ld4)
      double precision b(ld,ld),bm(ld,ld),bt(ld4,ld4),bvbt(ld,ld)
      double precision c(ld,ld),cm(ld,ld),ct(ld4,ld4),ctrc(ld,ld)
      double precision d(ld,ld),e(ld,ld),e1(ld),e2(ld),eps,fvec(nn+1)
      double precision gc(ld,ld),go(ld,ld),lu(ld,ld),mat2(ld,ld)
      double precision p(ld,ld),q(ld,ld),qr(350,350),r(ld,ld)
      double precision rt(ld4,ld4),s(ld),s1(ld),sigma(ld,ld),tau(ld,ld)
      double precision temp1(ld,ld),temp2(ld,ld),temp3(ld,ld)
      double precision temp4(ld4,ld4),temp5(ld4,ld4),temp6(ld4,ld4)
      double precision v(ld,ld),vt(ld4,ld4),wa(60000),wi(ld,ld)
      double precision work(ld,ld),ww(ld,ld),y(nn+1)
*
      job = 11
      z = ld * ld
      eps = 1.d-16
*
      call bvrc(ld,n,m,l,b,c,bvbt,ctrc,v,r,temp1)
*
* Compute Gramians and their rank-nm approximations
*
      call trans(ld,a,temp2,n,n)
      call scmat(ld,-1.d0,bvbt,temp1,n,n)
      call atxpxa(temp2,lu,temp1,n,ld,ld,ld,eps,ind)
      call scmat(ld,1.d0,temp1,gc,n,n)
*
      call dsvdc(temp1,ld,n,n,s,e,temp2,ld,temp3,ld,work,job,info)
      call setmat(ld,0.d0,sigma,n,n)
      do 311 i = 1,nm
        sigma(i,i) = s(i)
311   continue
      call mulmat(ld,temp2,sigma,temp1,n,n,n,1)
      call mulmat(ld,temp1,temp3,q,n,n,n,3)
*
      write(2,211)
211   format(/'singular values of Gc')
      call writev(s,n)
*
      call scmat(ld,1.d0,a,temp2,n,n)
      call scmat(ld,-1.d0,ctrc,temp1,n,n)
      call atxpxa(temp2,lu,temp1,n,ld,ld,ld,eps,ind)
      call scmat(ld,1.d0,temp1,go,n,n)
*
      call dsvdc(temp1,ld,n,n,s,e,temp2,ld,temp3,ld,work,job,info)
      call setmat(ld,0.d0,sigma,n,n)
      do 312 i = 1,nm
        sigma(i,i) = s(i)
312   continue
      call mulmat(ld,temp2,sigma,temp1,n,n,n,1)
      call mulmat(ld,temp1,temp3,p,n,n,n,3)
*
      write(2,212)
212   format(/'singular values of Go')
      call writev(s,n)
*
* Compute starting point (W,U,Sigma) for iteration starting from
* rank-nm approximations to Gramians
*
      call cg(ld,n,nm,q,p,ww,wi,sigma,tau,temp1,temp2,temp3,
     &        wa(1),wa(z+1),wa(2*z+1),wa(3*z+1),wa(4*z+1),wa(5*z+1),
     &        wa(6*z+1),wa(7*z+1),wa(8*z+1),wa(9*z+1),wa(10*z+1),
     &        wa(11*z+1))
*
* Evaluate starting point as a possible final solution
*
      write(2,221)
221   format(/'sigma')
      call writev(s,nm)
      write(2,222)
222   format(/'Gramians'/)
      do 323 i= 1,n
        do 324 j = 1,n
          write(2,223)i,j,gc(i,j),q(i,j),go(i,j),p(i,j)
223       format(2i3,4f17.8)
324     continue
323   continue
*
      call mulmat(ld,wi,a,temp1,nm,n,n,1)
      call mulmat(ld,temp1,ww,am,nm,nm,n,1)
      call mulmat(ld,wi,b,bm,nm,m,n,1)
      call mulmat(ld,c,ww,cm,l,nm,n,1)
*
      xtyp = 2
      call xwus(ld,n,nm,xtyp,ww,wi,sigma,y)
*
      write(2,241)
241   format(/'Am')
      call writem(ld,am,nm,nm)
      write(2,242)
242   format(/'Bm')
      call writem(ld,bm,nm,m)
      write(2,243)
243   format(/'Cm')
      call writem(ld,cm,l,nm)
      write(2,244)
244   format(/'eigenvalues of A')
      call eig(ld,n,trace,a,temp1,temp2,temp3,mat2,e1,e2)
      write(2,245)
245   format(/'eigenvalues of Am')
      call eig(ld,nm,trace,am,temp1,temp2,temp3,mat2,e1,e2)
*
      call eq12(ld,n,trace,a,bvbt,ctrc,q,p,tau,temp1,temp2,temp3)
*
      call cost(ld,ld4,n,nm,m,l,trace,a,bvbt,ctrc,am,bm,cm,b,c,v,r,
     &          temp1,temp2,temp3,at,bt,ct,vt,rt,temp4,temp5,temp6)
*
* Perform Quasi-Newton iteration
*
      call appra(ld,ld4,n,nm,m,l,nn,trace,y,a,bvbt,ctrc,am,bm,cm,b,c,
     &           v,r,q,p,tau,ww,wi,sigma,temp1,temp2,temp3,aal,
     &           at,bt,ct,vt,rt,temp4,temp5,temp6,mat2,e1,e2,s1,
     &           fvec,qr,wa)
*
      return
      end
