#include <stdio.h>
#include <math.h>
#include "macro.h"
#include "eglobal.h"

extern FILE *in, *out;
extern void initp(), fixpnfn(), atxpxa(), riccnd(), chkd(double *y); 
extern void fixpnf1(),free_dmatrix(), free_dvector(), free_ivector(); 
extern double **dmatrix(), *dvector();
extern int *ivector();

void track(double ansae,double arcae,double ansae1,double arcae1,
	   double hmax,int ip)
{
  register int i,j;
  int iflag,nfe,*ipivot, n4, trace;
  double  aa[1], arclen, sspar[8], *wa;
  double  *x, ansre, arcre;
  
  wa = dvector(0,40*nn+nn*nn+10*n2*n2);
  x = dvector(0,nn);
  ipivot =ivector(0,nn);

  initp();

  *x = 0.0;          /* Transfer bm, cm to array x  */
  toarray(nm,nm,am,(x+1));
  toarray(nm,m,bm,(x+1+nm*nm));
  toarray(l,nm,cm,(x+1+nm*m+nm*nm));

   addmat3(a,a0,adot,n,n);
   addmat3(b,b0,bdot,n,m);
   addmat3(c,c0,cdot,l,n);

/* chkd(x);  */

#if ((AIX) || (HP))
   rho(aa, x, x+1, wa, wa+nn+1, &ip);
#else
   rho_(aa, x, x+1, wa, wa+nn+1, &ip);
#endif


/* Compute average values of the initial homotopy map */ 
 
   sspar[0]  =  0.0;
   for(i=0;i<nn;i++) sspar[0] += myabs(*(wa+i));
    sspar[0] /= nn;
   if(sspar[0] > 1.0e-3)
     printf("The initial homotopy = %9.2E\n", sspar[0]);
 
   for(i=0;i<8; i++) sspar[i] = 0.0;
   sspar[4] = 1.0;
   iflag = -2;
   ansre = ansae;
   arcre = arcae;
 
/* Call tracking procedure             */ 
 
   n4 = nn + 1;
   for(i=0;i<10;i++){
#if ((AIX) || (HP))
    fixpnf1(&nn,x,&iflag,&arcre,&arcae,&ansre,&ansae,&trace,aa,&nfe,
#else
    fixpnf1_(&nn,x,&iflag,&arcre,&arcae,&ansre,&ansae,&trace,aa,&nfe,
#endif

          &arclen,wa,wa+n4,wa+2*n4,wa+3*n4,wa+5*n4+n4*n4,
          wa+6*n4+n4*n4, ipivot,wa+7*n4+n4*n4,wa+8*n4+n4*n4,
          wa+9*n4+n4*n4,wa+10*n4+n4*n4,sspar,wa+11*n4+n4*n4,&ip);
      if(iflag != 3) break;
    }

    tomatrix(nm,nm,am,x+1); /* Transform variable x to (Am, Bm, Cm)*/
    tomatrix(nm,m,bm,x+nm*nm+1); 
    tomatrix(l,nm,cm,x+nm*nm+nm*m+1);

    scmat(1.0, am, am0, nm,nm);
    scmat(1.0, bm, bm0, nm, m);
    scmat(1.0, cm, cm0, l ,nm);

    sspar[0] = x[0];
    g0 = sspar[0] * gf + (1- sspar[0])* g0;

    scmat(sspar[0],adot,ttemp1,n,n);/*  A0 + lambda *(A- A0) in temp1 */ 
    addmat1(a0,ttemp1,a0,n,n);

    scmat(sspar[0],bdot,ttemp1,n,m);/*  B0 + lambda *(B - B0) in temp2*/
    addmat1(b0,ttemp1,b0,n,m);
 
    scmat(sspar[0],cdot,ttemp1,l,n);/*  C0 + lambda *(C - C0) in temp3*/
    addmat1(c0,ttemp1,c0,l,n);

    addmat3(a,a0,adot,n,n);
    addmat3(b,b0,bdot,n,m);
    addmat3(c,c0,cdot,l,n);

   x[0] = 0;
   for(i=0;i<8; i++) sspar[i] = 0.0;
   sspar[4] = hmax;
   iflag = -2;
   ansre = ansae1;
   arcre = arcae1;
   ip  = ip<<1; 
 
   for(i=0;i<10;i++){
#if ((AIX) || (HP))
    fixpnfn(&nn,x,&iflag,&arcre,&arcae1,&ansre,&ansae1,&trace,aa,&nfe,
#else
    fixpnfn_(&nn,x,&iflag,&arcre,&arcae1,&ansre,&ansae1,&trace,aa,&nfe,
#endif

          &arclen,wa,wa+n4,wa+2*n4,wa+3*n4,wa+5*n4+n4*n4,
          wa+6*n4+n4*n4, ipivot,wa+7*n4+n4*n4,wa+8*n4+n4*n4,
          wa+9*n4+n4*n4,wa+10*n4+n4*n4,sspar,wa+11*n4+n4*n4,&ip);
      if(iflag != 3) break;
    }

   fprintf(out, "%u\n", iflag);
   fprintf(out, "%20.15E\n",*x);

#if ((AIX) || (HP))
   rho(aa, x, x+1, wa, wa+n4, &ip);
#else
   rho_(aa, x, x+1, wa, wa+n4, &ip);
#endif


    *sspar = 0.0;
    for(i=0;i<nn;i++) *sspar += myabs(*(wa+i));
    *sspar /= nn;
    if(*sspar > 1.0e-7) 
      printf("\nThe final solution = %9.2E\n", *sspar);

/* Compute the L^2 cost  */

   *sspar = 0;
   mulmat1(qt,rt,ttemp1,nt,nt,nt);
   for(i=0;i<nt;i++) *sspar += ttemp1[i][i];
   fprintf(out,"%19.7E\n", *sspar);

   *sspar = 1.0e-26;
   trarray(at,uat,nt,nt);
   scmat(-1.0,vt,ttemp1,nt,nt);
   tmparray(ttemp1,ua,nt,nt);
#if ((AIX) || (HP))
   atxpxa(uat, tarray1, ua, &nt, &nt12, &nt12, &nt12, sspar, &ip);
#else
   atxpxa_(uat, tarray1, ua, &nt, &nt12, &nt12, &nt12, sspar, &ip);
#endif


   tmpmatrix(ua,qt,nt,nt);
   mulmat1(qt,rt,ttemp1,nt,nt,nt);

   sspar[0] =0.0;
   for(i=0;i<nt;i++) sspar[0] += ttemp1[i][i];
   fprintf(out,"%19.7E\n", sspar[0]);

/* Print Am, Bm, Cm */
      for(i=0;i<nm;i++)
        for(j=0;j<nm;j++) fprintf(out,"%19.10E\n", am[i][j]);
      for(i=0;i<nm;i++)
        for(j=0;j<m;j++) fprintf(out,"%19.10E\n", bm[i][j]);
      for(i=0;i<l;i++)
        for(j=0;j<nm;j++) fprintf(out,"%19.10E\n", cm[i][j]);

   free_dvector(wa,0,40*nn+nn*nn + 10*n2);
   free_dvector(x,0,nn);
   free_ivector(ipivot,0,nn);
} 
