#include <stdlib.h>
#include <math.h>
#include "macro.h"
#include "eglobal.h"

void jaccm(double lambda, int k,int ll, double *y, int kk)
/* 
* JACCM evaluates kk-th column of Jacobian at given point w.r.t. Cm.
* Input parameters: k, ll -- the index of the element of Cm 
* Output parameters: * y - evaluated function
*/
{
      int ind;
      register int i,j;
      double eps = -1.0, beta;

       setmat(0.0,att,nt,nt); /* Derivative of A tilde */
       setmat(0.0,temp1,n,nc); 
       for(i=0;i<nc;i++) temp1[i][ll] = bl[i][k];
       for(i=0;i<n;i++)      
	  for(j=n;j<nt;j++) att[i][j]=temp1[i][j-n];

       beta = 2.0 *cc[k][ll]/ bcbct[ll][ll];   
       for(j=0;j<nc;j++){
         temp4[j][j] = cc[k][ll] * delta[j][ll] ;
         for(i=0;i<nc ;i++)
          if( i != j)
           temp4[i][j]=((1+ome[j][j])*(delta[ll][i]*cc[k][j]+delta[ll][j]  
                   *cc[k][i]) + beta * delta[ll][j] * cctcc[i][j]
                   -(1+ome[i][i])* beta * delta[ll][j] *bcbct[i][j]
                   - beta * delta[ll][i] * ome[j][j] * bcbct[i][j]
                   -(delta[j][ll]- delta[i][ll])*beta*ac[i][j])/
                   (ome[j][j] -ome[i][i]);
       }
       for(i=n;i<nt;i++)
         for(j=n;j<nt;j++) att[i][j] = temp4[i-n][j-n];


       for (i=0;i<nt;i++) /* Derivative of R tilde inf     */  
	  for(j=0;j<nt;j++) rtt[i][j]=0.0; 

       setmat(0.0,temp1,nc,nc); /* Cc^t R2i E^(k,ll)+E^(ll,k) R2i Cc  */
       for(j=0;j<nc;j++) temp1[ll][j] = r2icc[k][j];
       trans(temp1,temp2,nc,nc);
       addmat1(temp1,temp2,ttemp1,nc,nc);
       for(i=n;i<nt;i++) /*  22 block of Rti^(j) */
	  for(j=n;j<nt;j++) rtt[i][j]=ttemp1[i-n][j-n];

       for (i=0;i<nt;i++) /* Derivative of R tilde in vtt */  
	  for(j=0;j<nt;j++) vtt[i][j]=0.0; 

       setmat(0.0,temp1,nc,nc); /* Cc^tR2E^(k,ll)+E^(ll,k) R2 Cc  */
       for(j=0;j<nc;j++) temp1[ll][j] = r2cc[k][j];
       trans(temp1,temp2,nc,nc);
       addmat1(temp1,temp2,ttemp1,nc,nc);
       for(i=n;i<nt;i++) /*  22 block of Rt^(j) */
	  for(j=n;j<nt;j++) vtt[i][j]=ttemp1[i-n][j-n];

      scmat(gaman2,rtt,ttemp2,nt,nt); /* Q^(j) */
      mulmat1(ttemp2,qt,ttemp1,nt,nt,nt);
      mulmat1(qt,ttemp1,ttemp2,nt,nt,nt);

      mulmat1(att,qt,ttemp1,nt,nt,nt);
      trans(ttemp1,ttemp3,nt,nt);
      addmat1(ttemp1,ttemp3,ttemp1,nt,nt);
      addmat4(ttemp1,ttemp2,ttemp1,nt,nt);
      tmparray(ttemp1,tarray2,nt,nt);

#if ((AIX) || (HP))
      atxpxa(ua,va,tarray2,&nt,&nt12,&nt12,&nt12,&eps,&ind);
#else
      atxpxa_(ua,va,tarray2,&nt,&nt12,&nt12,&nt12,&eps,&ind);
#endif

      tmpmatrix(tarray2,ttemp1,nt,nt);
      partition(ttemp1,qtd1,qtd12,qtd2,n,nt);

      mulmat1(ttemp1,rti,ttemp2,nt,nt,nt); /* Compute P^(j) */
      mulmat1(qt,rtt,ttemp1,nt,nt,nt);
      addmat1(ttemp1,ttemp2,ttemp3,nt,nt);
      scmat(gaman2,ttemp3,ttemp1,nt,nt);
      addmat1(att,ttemp1,ttemp1,nt,nt);
      mulmat2(ttemp1,pt,ttemp2,nt,nt,nt);
      trans(ttemp2,ttemp3,nt,nt);
      addmat1(ttemp2,ttemp3,ttemp1,nt,nt);
      addmat4(vtt,ttemp1,ttemp3,nt,nt);
      tmparray(ttemp3,tarray2,nt,nt);

#if ((AIX) || (HP))
      atxpxa(uat,vat,tarray2,&nt,&nt12,&nt12,&nt12,&eps,&ind);
#else
      atxpxa_(uat,vat,tarray2,&nt,&nt12,&nt12,&nt12,&eps,&ind);
#endif

      tmpmatrix(tarray2,ttemp1,nt,nt);
      partition(ttemp1,ptd1,ptd12,ptd2,n,nt);
         

/* Compute derivative of H_Bc  */
      mulmat2(ptd12,qt12,ttemp1,nc,nc,n); 
      mulmat2(pt12,qtd12,ttemp2,nc,nc,n);  
      addmat1(ttemp1,ttemp2,ttemp1,nc,nc);

      mulmat1(ptd2,qt2,ttemp2,nc,nc,nc);
      mulmat1(pt2,qtd2,ttemp3,nc,nc,nc);  
      addmat1(ttemp2,ttemp3,ttemp2,nc,nc);
 
      addmat1(ttemp1,ttemp2,ttemp3,nc,nc);

     for(j=0;j<nc;j++) /* Mo^(j) in temp3        */
        for(i=j+1;i<nc;i++){
         temp3[i][j]= (ttemp3[i][j] -ttemp3[j][i]- mo[i][j]*beta *
           (delta[j][ll] -delta[i][ll]) )/(ome[j][j] -ome[i][i]) ;
            temp3[j][i] = temp3[i][j];
        }
      for(i=0;i<nc;i++){
        temp3[i][i] = 0.0;
        for(j=0;j<nc;j++) 
            if(i != j)
            temp3[i][i] += (ac[i][j]+ bcbct[i][j]*ome[j][j])*temp3[j][i] 
            +(temp4[i][j]+beta*delta[j][ll]*bcbct[i][j] )*mo[j][i];
        temp3[i][i] = -((temp4[i][i]+beta*delta[i][ll]*bcbct[i][i])*mo[i][i]
                        + temp3[i][i] ) /(ac[i][i] + bcbct[i][i]*ome[i][i]);
       }

     setmat(0.0,temp1,nc,nc);
     temp1[ll][ll] = beta;

     mulmat1(temp1,mo,temp2,nc,nc,nc); /*  Mc^(j) in temp1  */
     mulmat1(ome,temp3,ttemp1,nc,nc,nc);

     addmat1(temp2,ttemp1,temp1,nc,nc);
     addmat4(temp1,ttemp3,temp1,nc,nc);

     for(i=0;i<nc;i++)
         for(j=0;j<nc;j++)
           temp2[i][j] =temp1[i][j]- ome[i][i]*temp3[i][j]*ome[j][j]
               - beta*delta[i][ll]*mo[i][j]*ome[j][j]
               - ome[i][i]*mo[i][j]*beta*delta[j][ll] ;
      mulmat1(temp2,bc,temp4,nc,l,nc);

      hbchat();

      addmat1(temp4,ttemp3,ttemp1,nc,l);
      toarray(nc,l,ttemp1,y);
 
/* Compute derivative of H_Cc       */

/* Originial terms                  */ 

       addmat3(temp3,temp1,temp2,nc,nc);
       mulmat1(cc, temp2,temp1,m,nc,nc);

       setmat(0.00,temp2,m,nc);
       for(j=0;j<nc;j++) temp2[k][j] = qt2[ll][j];
       scmat(lambda,r2dot,ttemp1,m,m);
       addmat1(r20,ttemp1,ttemp2,m,m); /* R2 (lambda) */
       mulmat1(ttemp2,temp2,temp4,m,nc,m);

       addmat1(temp1,temp4,temp4,m,nc);

       eps = 0.5 * gaman2;
       scmat(eps,cy,temp3,nc,nc);

       setmat(0.00,temp2,m,nc);
       for(j=0;j<nc;j++) temp2[k][j] = temp3[ll][j];

       scmat(lambda,r2idot,ttemp1,m,m);  /* R2i(lambda)  */
       addmat1(r2i0,ttemp1,ttemp2,m,m);
       mulmat1(ttemp2,temp2,temp3,m,nc,m);

       addmat1(temp4,temp3,temp2,m,nc);
       
       setmat(0.0, temp1, nc,nc);
       for(i=0;i<nc;i++) temp1[k][i] = mo[ll][i] - mc[ll][i];
       
       addmat1(temp2,temp1,temp4,m,nc);

       hcchat();

       addmat1(ttemp3,temp4,temp3,m,nc);
       toarray(m,nc,temp3,y+(nc*l));
       for (i =0;i<nn;i++) y[i] = lambda * y[i];
       y[kk-2] += 1 - lambda;      
}
