function ret = randn(m,n)

%==================================================================
% RANDN  Normally distributed random numbers and matrices.
%        RANDN(N) is an N-by-N matrix with random entries, chosen
%        from a normal distribution with mean 0.0 and variance 1.0.
%        RANDN(M,N) or RANDN([M,N]) is an M-by-N matrix with random
%        entries.  RANDN(SIZE(A)) is the same size as A.
%        RANDN with no arguments is a scalar whose value changes
%        each time it is referenced.
%
%        RANDN('seed') returns the current value of the seed for the
%        normal generator.  RANDN('seed',n) sets the seed to n.
%        RANDN('seed',0) resets the seed to 0, its value when MATLAB
%        is first entered.
%
%        See also: RAND.
%
%        Copyright (c) 1991-92 by the MathWorks, Inc.
%
%        This function is a built in function in MATLAB Version 4.0
%
%====================================================================
    rand('normal');

 if nargin == 1

          p = prod(size(m));

              if p == 1

                       r = rand(m,m);

                  elseif (p == 2)

                 r = rand(m(1),m(2));

            elseif isstr(m)

                 if nargin == 2

                          r=rand(m,n);

                            else

                            r=rand(m);

                              end

             else
                    r = rand(m)
                     error('old syntax for rand')
            end

     elseif nargin == 0

              r = rand(1);

    else

            r = rand(m,n);

  end

     rand('uniform')

 if ~isempty(r)

          ret = r;

        end


