function [A,B,C,D] = tito2siso(A,Bu,Bw,Cy,Cz,Dyu,Dyw,Dzu,Dzw)
%
% TITO2SISO	convert state space from two vector-input/two
%		vector-output to one vector-input/one vector-output.
%
%		[A,B,C,D] = tito2siso(A,Bu,Bw,Cy,Cz,Dyu,Dyw,Dzu,Dzw) 
%		performs the following conversion:
%		
%			.
%			x = A  x + Bu  u + Bw  w
%
%			y = Cy x + Dyu u + Dyw w
%
%			z = Cz x + Dzu u + Dzw w
%
%		to
%			. 
%			x = A x + B | u | , | y | = C x + D | u |
%				    | w |   | z |           | w |
%
%

B  = [Bu,Bw];
C  = [Cy;Cz];
D  = [Dyu,Dyw;Dzu,Dzw];
